'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _dec, _dec2, _desc, _value, _class, _class2, _temp;

var _ReduxComponent = require('redux-components/lib/ReduxComponent');

var _ReduxComponent2 = _interopRequireDefault(_ReduxComponent);

var _action = require('redux-components/lib/decorators/action');

var _action2 = _interopRequireDefault(_action);

var _selector = require('redux-components/lib/decorators/selector');

var _selector2 = _interopRequireDefault(_selector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// A ValueStore is a state node that stores a fully-opaque value.
let ValueStore = (_dec = (0, _action2.default)({ isDispatcher: true }), _dec2 = (0, _selector2.default)({ isObservable: true }), (_class = (_temp = _class2 = class ValueStore extends _ReduxComponent2.default {

  reducer(state = null, action) {
    if (action.type === this.SET) {
      if (action.payload !== undefined) return action.payload;else return null;
    } else {
      return state;
    }
  }
  set(value) {
    return { type: this.SET, payload: value };
  }

  get(state) {
    return state;
  }
}, _class2.verbs = ['SET'], _temp), (_applyDecoratedDescriptor(_class.prototype, 'set', [_dec], Object.getOwnPropertyDescriptor(_class.prototype, 'set'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'get', [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, 'get'), _class.prototype)), _class));
exports.default = ValueStore;